

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.8.15. TokenRegexp &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.8.16. TokenTable" href="token_table.html" />
    <link rel="prev" title="7.8.14. TokenPattern" href="token_pattern.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/tokenizers/token_regexp.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="token_table.html" title="7.8.16. TokenTable"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="token_pattern.html" title="7.8.14. TokenPattern"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" accesskey="U"><span class="section-number">7.8. </span>Tokenizers</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.15. </span><code class="docutils literal notranslate"><span class="pre">TokenRegexp</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="tokenregexp">
<span id="token-regexp"></span><h1><span class="section-number">7.8.15. </span><code class="docutils literal notranslate"><span class="pre">TokenRegexp</span></code><a class="headerlink" href="#tokenregexp" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.8.15.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">New in version 5.0.1.</span></p>
</div>
<div class="admonition caution">
<p class="admonition-title">Caution</p>
<p>This tokenizer is experimental. Specification may be changed.</p>
</div>
<div class="admonition caution">
<p class="admonition-title">Caution</p>
<p>This tokenizer can be used only with UTF-8. You can’t use this
tokenizer with EUC-JP, Shift_JIS and so on.</p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">TokenRegexp</span></code> is a tokenizer for supporting regular expression
search by index.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.8.15.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">TokenRegexp</span></code> hasn’t parameter:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>TokenRegexp
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.8.15.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>In general, regular expression search is evaluated as sequential
search. But the following cases can be evaluated as index search:</p>
<blockquote>
<div><ul class="simple">
<li><p>Literal only case such as <code class="docutils literal notranslate"><span class="pre">hello</span></code></p></li>
<li><p>The beginning of text and literal case such as <code class="docutils literal notranslate"><span class="pre">\A/home/alice</span></code></p></li>
<li><p>The end of text and literal case such as <code class="docutils literal notranslate"><span class="pre">\.txt\z</span></code></p></li>
</ul>
</div></blockquote>
<p>In most cases, index search is faster than sequential search.</p>
<p><code class="docutils literal notranslate"><span class="pre">TokenRegexp</span></code> is based on bigram tokenize method. <code class="docutils literal notranslate"><span class="pre">TokenRegexp</span></code>
adds the beginning of text mark (<code class="docutils literal notranslate"><span class="pre">U+FFEF</span></code>) at the begging of text
and the end of text mark (<code class="docutils literal notranslate"><span class="pre">U+FFF0</span></code>) to the end of text when you
index text:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>tokenize TokenRegexp &quot;/home/alice/test.txt&quot; NormalizerAuto --mode ADD
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     {
#       &quot;position&quot;: 0,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;￯&quot;
#     },
#     {
#       &quot;position&quot;: 1,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;/h&quot;
#     },
#     {
#       &quot;position&quot;: 2,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ho&quot;
#     },
#     {
#       &quot;position&quot;: 3,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;om&quot;
#     },
#     {
#       &quot;position&quot;: 4,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;me&quot;
#     },
#     {
#       &quot;position&quot;: 5,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;e/&quot;
#     },
#     {
#       &quot;position&quot;: 6,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;/a&quot;
#     },
#     {
#       &quot;position&quot;: 7,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;al&quot;
#     },
#     {
#       &quot;position&quot;: 8,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;li&quot;
#     },
#     {
#       &quot;position&quot;: 9,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ic&quot;
#     },
#     {
#       &quot;position&quot;: 10,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;ce&quot;
#     },
#     {
#       &quot;position&quot;: 11,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;e/&quot;
#     },
#     {
#       &quot;position&quot;: 12,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;/t&quot;
#     },
#     {
#       &quot;position&quot;: 13,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;te&quot;
#     },
#     {
#       &quot;position&quot;: 14,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;es&quot;
#     },
#     {
#       &quot;position&quot;: 15,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;st&quot;
#     },
#     {
#       &quot;position&quot;: 16,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;t.&quot;
#     },
#     {
#       &quot;position&quot;: 17,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;.t&quot;
#     },
#     {
#       &quot;position&quot;: 18,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;tx&quot;
#     },
#     {
#       &quot;position&quot;: 19,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;xt&quot;
#     },
#     {
#       &quot;position&quot;: 20,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;t&quot;
#     },
#     {
#       &quot;position&quot;: 21,
#       &quot;force_prefix&quot;: false,
#       &quot;value&quot;: &quot;￰&quot;
#     }
#   ]
# ]
</pre></div>
</div>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.8.15. <code class="docutils literal notranslate"><span class="pre">TokenRegexp</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.8.15.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.8.15.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.8.15.3. Usage</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="token_pattern.html"
                        title="previous chapter"><span class="section-number">7.8.14. </span><code class="docutils literal notranslate"><span class="pre">TokenPattern</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="token_table.html"
                        title="next chapter"><span class="section-number">7.8.16. </span><code class="docutils literal notranslate"><span class="pre">TokenTable</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="token_table.html" title="7.8.16. TokenTable"
             >next</a> |</li>
        <li class="right" >
          <a href="token_pattern.html" title="7.8.14. TokenPattern"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../tokenizers.html" ><span class="section-number">7.8. </span>Tokenizers</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.8.15. </span><code class="docutils literal notranslate"><span class="pre">TokenRegexp</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>